library(fda)
library(MASS)
library(Matrix)
library(survival)
library(seqMeta)

source("C:/NICHD/Research/software/Fan/FLM_survival/FLM_surv/FLM_survival_fixed_model.R")
source("C:/NICHD/Research/software/Fan/FLM_survival/FLM_surv/FLM_survival_beta_smooth_only.R")

data(SNPInfo)
data(seqMetaExample)

cov <- as.matrix(pheno1[,2:3])
position <- 1: nrow(SNPInfo)
VariantInfo <- SNPInfo[SNPInfo[,1] %in% colnames(Z1),]
dim(VariantInfo)
Z1[Z1==NA] <- 0

order  =  4
bbasis = 10
gbasis = 10
fbasis = 11
gfasis = 11

rlt <- data.frame()

for (i in 1:length(unique(VariantInfo$gene)))
   {
   Gene <- unique(VariantInfo$gene)[i]
   choose <- VariantInfo$gene == Gene
   pos <- position[choose]
   geno <- Z1[,choose]
  
   cohort1 <- prepCox(Z=Z1, Surv(time, status) ~ strata(sex) + bmi, SNPInfo = VariantInfo[choose,], data = pheno1)
   skatMeta_out <- skatMeta(cohort1, SNPInfo = VariantInfo[choose,])
   burdenMeta_out <- burdenMeta(cohort1, SNPInfo = VariantInfo[choose,])
      
   Fixed_model_pvalue.bs = flm_surv_fixed_model(pheno1$time, pheno1$status, mode = "Additive", geno, pos, order, bbasis, fbasis, gbasis, covariate = cov, base = "bspline")
   Fixed_model_pvalue.fs = flm_surv_fixed_model(pheno1$time, pheno1$status, mode = "Additive", geno, pos, order, bbasis, fbasis, gfasis, covariate = cov, base = "fspline")
   fit.beta.smooth.only.bs = flm_surv_beta_smooth_only(pheno1$time, pheno1$status, mode = "Additive", geno, pos, order, bbasis, covariate = cov, base = "bspline")
   fit.beta.smooth.only.fs = flm_surv_beta_smooth_only(pheno1$time, pheno1$status, mode = "Additive", geno, pos, order, fbasis, covariate = cov, base = "fspline")
  
   rlt[i, "Gene"] <- skatMeta_out[1]
   rlt[i, "Cox FR LRT:fixed_b"] <- Fixed_model_pvalue.bs
   rlt[i, "Cox FR LRT:fixed_f"] <- Fixed_model_pvalue.fs
   rlt[i, "Cox FR LRT:beta_b"] <- fit.beta.smooth.only.bs
   rlt[i, "Cox FR LRT:beta_f"] <- fit.beta.smooth.only.fs      
   }

rlt


